#! /bin/sh

MachineHwVersion=`cat /proc/sys/kernel/syno_hw_version | cut -d '-' -f1`
MachineHwRevision=`cat /proc/sys/kernel/syno_hw_revision`
UbootImage="uboot.bin"

need_update()
{
    cp ${UbootImage} RedBoot.msys
    logger -p user.err "need to update"
}

if [ $MachineHwVersion = RS217 ]; then
	case "$MachineHwRevision" in
		r1)
			UbootImage="uboot_${MachineHwVersion}${MachineHwRevision}.bin"
			;;
		*)
			UbootImage="uboot_$MachineHwVersion.bin"
			;;
	esac
	if [ -f ${UbootImage} ]; then
		PUbootVer=`grep -a syno_fw_version ${UbootImage} | grep -ao "M.[0-9][0-9][0-9]" \
			| cut -c 4-`
		if [ -z $PUbootVer ]; then
			logger -p user.err "Uboot version on patch not found"
			exit 1
		fi
	else
		logger -p user.err "can't find uboot update image on patch"
		exit 1
	fi

	MUbootVer=`cat /proc/cmdline | grep -ao "M.[0-9][0-9][0-9]" \
		| cut -c 4-`

	if [ -z $MUbootVer ]; then
		logger -p user.err "current uboot version not found, could be an older version"
		need_update
		exit 0
	fi

	logger -p user.err "patch uboot version=$PUbootVer and current uboot version=$MUbootVer"
	if [ $PUbootVer -gt $MUbootVer ]; then
		need_update
		exit 0
	else
		logger -p user.err "need not to update"
		exit 1
	fi
fi

